unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, DB, DBClient, Grids, DBGrids, StdCtrls, ExtCtrls, OGLPanel, OpenGL,
  ComCtrls, DBCtrls, Spin, OBJLoader;

type
  TForm1 = class(TForm)
    DataSource1: TDataSource;
    DBGrid1: TDBGrid;
    Button1: TButton;
    SaveDialog1: TSaveDialog;
    ClientDataSet1: TClientDataSet;
    Button2: TButton;
    Button3: TButton;
    OpenDialog1: TOpenDialog;
    OGLPanel1: TOGLPanel;
    Timer1: TTimer;
    RadioGroup1: TRadioGroup;
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    ColorDialog1: TColorDialog;
    Shape1: TShape;
    Label1: TLabel;
    Edit4: TEdit;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    TrackBar1: TTrackBar;
    Label5: TLabel;
    Edit5: TEdit;
    Edit6: TEdit;
    Edit7: TEdit;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Edit8: TEdit;
    Edit9: TEdit;
    Edit10: TEdit;
    Label10: TLabel;
    Edit11: TEdit;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    Button5: TButton;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    DBNavigator1: TDBNavigator;
    Label14: TLabel;
    CheckBox3: TCheckBox;
    CheckBox4: TCheckBox;
    RadioGroup2: TRadioGroup;
    Edit12: TEdit;
    Edit13: TEdit;
    Edit14: TEdit;
    Label15: TLabel;
    Label16: TLabel;
    Label17: TLabel;
    Edit15: TEdit;
    Label18: TLabel;
    SpinButton1: TSpinButton;
    Edit16: TEdit;
    Label19: TLabel;
    Shape2: TShape;
    SpinButton2: TSpinButton;
    Label20: TLabel;
    Label21: TLabel;
    SpinButton3: TSpinButton;
    Label22: TLabel;
    SpinButton4: TSpinButton;
    SpinButton5: TSpinButton;
    RadioGroup3: TRadioGroup;
    CheckBox5: TCheckBox;
    CheckBox6: TCheckBox;
    CheckBox7: TCheckBox;
    Label23: TLabel;
    Edit17: TEdit;
    CheckBox8: TCheckBox;
    CheckBox9: TCheckBox;
    CheckBox10: TCheckBox;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure TrackBar1Change(Sender: TObject);
    procedure RadioGroup1Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Shape1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure DBNavigator1Click(Sender: TObject; Button: TNavigateBtn);
    procedure SpinButton1DownClick(Sender: TObject);
    procedure SpinButton1UpClick(Sender: TObject);
    procedure SpinButton2DownClick(Sender: TObject);
    procedure SpinButton2UpClick(Sender: TObject);
    procedure SpinButton3DownClick(Sender: TObject);
    procedure SpinButton3UpClick(Sender: TObject);
    procedure SpinButton4UpClick(Sender: TObject);
    procedure SpinButton4DownClick(Sender: TObject);
    procedure SpinButton5DownClick(Sender: TObject);
    procedure SpinButton5UpClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  t: real = 0;
  reg: integer = 0;
  zoom: real = 0;
  CamX: real = 0;
  CamY: real = 0;
  CamZ: real = 0;

  // Lighting
  LightPos1 : Array[0..3] of glFloat = ( 40.0, 0.0, 0.0, 1.0);	// Light Position
  LightPos2 : Array[0..3] of glFloat = ( 0.0, 40.0, 0.0, 1.0);	// Light Position
  LightPos3 : Array[0..3] of glFloat = ( 0.0, 0.0, 40.0, 1.0);	// Light Position
  LightAmb : Array[0..3] of glFloat = ( 0.2, 0.2, 0.2, 1.0);	// Ambient Light Values
  LightDif : Array[0..3] of glFloat = ( 0.3, 0.3, 0.3, 1.0);	// Diffuse Light Values
  LightSpc : Array[0..3] of glFloat = ( 0.1, 0.1, 0.1, 1.0);	// Specular Light Values

  // Material
  ka : Array[0..3] of glFloat = ( 0.2, 0.2, 0.2, 1.0);
  kd : Array[0..3] of glFloat = ( 0.8, 0.8, 0.8, 1.0);
  ks : Array[0..3] of glFloat = ( 0.2, 0.2, 0.2, 1.0);



implementation

{$R *.dfm}

procedure CriaBancoDeDados(var cds: TClientDataSet);
procedure CriaCampo(var cds: TClientDataSet; nome: string; Tipo: TFieldType; tamanho: integer=50);
var field: TField;
begin
  with cds do
    begin
    case Tipo of
      ftString:
        begin
        Field := TStringField.Create(cds);
        Field.Size := tamanho;
        end;
      ftInteger: Field := TIntegerField.Create(cds);
      ftFloat: Field := TFloatField.Create(cds);
      ftBoolean: Field := TBooleanField.Create(cds);
    end;

    with Field do
      begin
      FieldName := Nome;
      Name := 'ClientDataSet1' + FieldName;
      FieldKind := fkData;
      DataSet := cds;
      end;
    end;
end;

begin

  with cds do
    begin
    CriaCampo(cds,'Nome',ftString,20);
    CriaCampo(cds,'ID',ftInteger);
    CriaCampo(cds,'X',ftFloat);
    CriaCampo(cds,'Y',ftFloat);
    CriaCampo(cds,'Z',ftFloat);
    CriaCampo(cds,'Ang',ftFloat);
    CriaCampo(cds,'eixoX',ftFloat);
    CriaCampo(cds,'eixoY',ftFloat);
    CriaCampo(cds,'eixoZ',ftFloat);
    CriaCampo(cds,'SX',ftFloat);
    CriaCampo(cds,'SY',ftFloat);
    CriaCampo(cds,'SZ',ftFloat);
                                   // esf  | caixa | plano | cap  |
    CriaCampo(cds,'Dim1',ftFloat); // raio | LadoX |   a   | raio |
    CriaCampo(cds,'Dim2',ftFloat); //      | LadoY |   b   | comp |
    CriaCampo(cds,'Dim3',ftFloat); //      | LadoZ |   c   |      |
    CriaCampo(cds,'Dim4',ftFloat); //      |       |   d   |      |
    CriaCampo(cds,'Massa',ftFloat);
    CriaCampo(cds,'R',ftFloat);
    CriaCampo(cds,'G',ftFloat);
    CriaCampo(cds,'B',ftFloat);
    CriaCampo(cds,'A',ftFloat);
    CriaCampo(cds,'UsaCor',ftBoolean);
    CriaCampo(cds,'Arquivo',ftString,255);
    CriaCampo(cds,'UserMove',ftBoolean);
    CriaCampo(cds,'MoveX',ftBoolean);
    CriaCampo(cds,'MoveY',ftBoolean);
    CriaCampo(cds,'MoveZ',ftBoolean);
    CriaCampo(cds,'ODEMove',ftBoolean);
    CriaCampo(cds,'ODETipo',ftInteger);
    CriaCampo(cds,'MostraRastroSempre',ftBoolean);
    CriaCampo(cds,'MostraRastroSolto',ftBoolean);
    CriaCampo(cds,'MostraVecV',ftBoolean);
    CriaCampo(cds,'MostraVecA',ftBoolean);
    CriaCampo(cds,'MostraEixoRot',ftBoolean);
    CriaCampo(cds,'TipoDeColisao',ftInteger);
    CriaCampo(cds,'Atrito',ftFloat);
    CriaCampo(cds,'TemGravidade',ftBoolean);

    CreateDir(ExtractFilePath(Application.ExeName) + 'Cenas');
    DeleteFile(ExtractFilePath(Application.ExeName) + 'Cenas\temp.xml');
    FileName := ExtractFilePath(Application.ExeName) + 'Cenas\temp.xml';
    CreateDataSet;
    Active := true;
    end;
end;




procedure TForm1.Button1Click(Sender: TObject);
var grava: boolean;
begin
SaveDialog1.Filter := 'Arquivo de cena (.xml)|*xml';
SaveDialog1.InitialDir := ExtractFilePath(Application.ExeName) + 'Cenas';
if SaveDialog1.Execute then
  begin
  grava := true;
  if FileExists(SaveDialog1.FileName) and (ClientDataSet1.FileName <> SaveDialog1.FileName) then
    grava := MessageDlg('O arquivo ' + SaveDialog1.FileName + ' j existe. Deseja sobrescrever?',mtConfirmation, mbOKCancel, 0) = mrOk;

  if grava then
    begin
    ClientDataSet1.Active := false;

    if LowerCase(copy(SaveDialog1.FileName,length(SaveDialog1.FileName)-3,4)) <> '.xml' then
      SaveDialog1.FileName := SaveDialog1.FileName + '.xml';
    CopyFile(pchar(ClientDataSet1.filename),pchar(SaveDialog1.FileName),false);

    ClientDataSet1.FileName := SaveDialog1.FileName;
    ClientDataSet1.Active := true;
    end;          
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  CriaBancoDeDados(ClientDataSet1);

  // configuraes iniciais
  glClearColor(0.0, 0.0, 0.0, 0.0); 	   // Black Background
  glShadeModel(GL_SMOOTH);                 // Enables Smooth Color Shading
  glClearDepth(1.0);                       // Depth Buffer Setup
  glEnable(GL_DEPTH_TEST);                 // Enable Depth Buffer
  glDepthFunc(GL_LESS);		           // The Type Of Depth Test To Do
  glDisable(GL_CULL_FACE);

  glHint(GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST);   //Realy Nice perspective calculations

  // Turn on OpenGL lighting
  glLightfv(GL_LIGHT1, GL_POSITION, @LightPos1);	// Set Light1 Position
  glLightfv(GL_LIGHT1, GL_AMBIENT, @LightAmb);		// Set Light1 Ambience
  glLightfv(GL_LIGHT1, GL_DIFFUSE, @LightDif);		// Set Light1 Diffuse
  glLightfv(GL_LIGHT1, GL_SPECULAR, @LightSpc);		// Set Light1 Specular
  glLightf(GL_LIGHT1, GL_QUADRATIC_ATTENUATION, 0);
  glLightf(GL_LIGHT1, GL_LINEAR_ATTENUATION, 0);
  glLightf(GL_LIGHT1, GL_CONSTANT_ATTENUATION, 1);
  glEnable(GL_LIGHT1);					// Enable Light1

  glLightfv(GL_LIGHT2, GL_POSITION, @LightPos2);	// Set Light2 Position
  glLightfv(GL_LIGHT2, GL_AMBIENT, @LightAmb);		// Set Light2 Ambience
  glLightfv(GL_LIGHT2, GL_DIFFUSE, @LightDif);		// Set Light2 Diffuse
  glLightfv(GL_LIGHT2, GL_SPECULAR, @LightSpc);		// Set Light2 Specular
  glLightf(GL_LIGHT2, GL_QUADRATIC_ATTENUATION, 0);
  glLightf(GL_LIGHT2, GL_LINEAR_ATTENUATION, 0);
  glLightf(GL_LIGHT2, GL_CONSTANT_ATTENUATION, 1);
  glEnable(GL_LIGHT2);					// Enable Light2

  glLightfv(GL_LIGHT3, GL_POSITION, @LightPos3);		// Set Light3 Position
  glLightfv(GL_LIGHT3, GL_AMBIENT, @LightAmb);		// Set Light3 Ambience
  glLightfv(GL_LIGHT3, GL_DIFFUSE, @LightDif);		// Set Light3 Diffuse
  glLightfv(GL_LIGHT3, GL_SPECULAR, @LightSpc);		// Set Light3 Specular
  glLightf(GL_LIGHT3, GL_QUADRATIC_ATTENUATION, 0);
  glLightf(GL_LIGHT3, GL_LINEAR_ATTENUATION, 0);
  glLightf(GL_LIGHT3, GL_CONSTANT_ATTENUATION, 1);
  glEnable(GL_LIGHT3);					// Enable Light3

  glEnable(GL_LIGHTING);				// Enable Lighting

  glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);

end;

procedure TForm1.Button2Click(Sender: TObject);
begin
OpenDialog1.Filter := 'Arquivo de cena (.xml)|*xml';
OpenDialog1.InitialDir := ExtractFilePath(Application.ExeName) + 'Cenas';
if OpenDialog1.Execute then
  begin
  ClientDataSet1.Active := false;
  ClientDataSet1.FileName := OpenDialog1.FileName;
  ClientDataSet1.Active := true;
  reg := 1;
  RadioGroup3.Enabled := true;
  end;
end;

procedure TForm1.Button3Click(Sender: TObject);
var de, para: string;
begin
  with ClientDataSet1 do
    begin
    Insert;
    FieldByName('Nome').AsString := Edit1.Text;
    FieldByName('ID').AsInteger := RecordCount;
    if RadioGroup1.ItemIndex = 3 then  // plano
      begin
      FieldByName('SX').AsFloat := StrToFloat(Edit2.Text);
      FieldByName('SY').AsFloat := StrToFloat(Edit3.Text);
      FieldByName('X').AsFloat := 0;
      FieldByName('Y').AsFloat := 0;
      FieldByName('Z').AsFloat := 0;
      FieldByName('Ang').AsFloat := 0;
      FieldByName('eixoX').AsFloat := 0;
      FieldByName('eixoY').AsFloat := 0;
      FieldByName('eixoZ').AsFloat := 0;
      FieldByName('ODEMove').AsBoolean := False;
      FieldByName('UserMove').AsBoolean := False;
      FieldByName('TemGravidade').AsBoolean := False;
      FieldByName('MostraVecV').AsBoolean := false;
      FieldByName('MostraVecA').AsBoolean := false;
      FieldByName('MostraEixoRot').AsBoolean := false;
      FieldByName('TipoDeColisao').AsInteger := 0;
      FieldByName('MostraRastroSempre').AsBoolean := false;
      FieldByName('MostraRastroSolto').AsBoolean := false;
      FieldByName('Atrito').AsFloat := 0;
      end
    else
      begin
      FieldByName('X').AsFloat := StrToFloat(Edit2.Text);
      FieldByName('Y').AsFloat := StrToFloat(Edit3.Text);
      FieldByName('Z').AsFloat := StrToFloat(Edit4.Text);
      FieldByName('SX').AsFloat := 1;
      FieldByName('SY').AsFloat := 1;
      FieldByName('SZ').AsFloat := 1;
      FieldByName('Ang').AsFloat := StrToFloat(Edit16.Text);
      FieldByName('eixoX').AsFloat := StrToFloat(Edit5.Text);
      FieldByName('eixoY').AsFloat := StrToFloat(Edit6.Text);
      FieldByName('eixoZ').AsFloat := StrToFloat(Edit7.Text);
      FieldByName('UserMove').AsBoolean := CheckBox6.Checked;
      FieldByName('MoveX').AsBoolean := CheckBox8.Checked;
      FieldByName('MoveY').AsBoolean := CheckBox9.Checked;
      FieldByName('MoveZ').AsBoolean := CheckBox10.Checked;
      FieldByName('ODEMove').AsBoolean := CheckBox1.Checked;
      FieldByName('MostraVecV').AsBoolean := CheckBox3.Checked;
      FieldByName('MostraVecA').AsBoolean := CheckBox4.Checked;
      FieldByName('MostraEixoRot').AsBoolean := CheckBox5.Checked;
      FieldByName('TipoDeColisao').AsInteger := RadioGroup3.ItemIndex;
      FieldByName('Atrito').AsFloat := StrToFloat(Edit17.Text);
      FieldByName('MostraRastroSempre').AsBoolean := RadioGroup2.ItemIndex = 1;
      FieldByName('MostraRastroSolto').AsBoolean := RadioGroup2.ItemIndex = 2;
      FieldByName('TemGravidade').AsBoolean := CheckBox7.Checked;
      end;

    FieldByName('ODETipo'). AsInteger := RadioGroup1.ItemIndex;
    FieldByName('UsaCor').AsBoolean := CheckBox2.Checked;
    FieldByName('R').AsInteger := GetRValue(Shape1.Brush.Color);
    FieldByName('G').AsInteger := GetGValue(Shape1.Brush.Color);
    FieldByName('B').AsInteger := GetBValue(Shape1.Brush.Color);
    FieldByName('A').AsInteger := TrackBar1.Position;

    if Edit15.Visible then
      FieldByName('Massa').AsFloat := StrToFloat(Edit15.Text);
    if Edit8.Visible then
      FieldByName('Dim1').AsFloat := StrToFloat(Edit8.Text);
    if Edit9.Visible then
      FieldByName('Dim2').AsFloat := StrToFloat(Edit9.Text);
    if Edit10.Visible then
      FieldByName('Dim3').AsFloat := StrToFloat(Edit10.Text);
    if Edit11.Visible then
      FieldByName('Dim4').AsFloat := StrToFloat(Edit11.Text);


    if RadioGroup1.ItemIndex = RadioGroup1.Items.Count-1 then // TriMesh
      begin
      FieldByName('SX').AsFloat := StrToFloat(Edit12.Text);
      FieldByName('SY').AsFloat := StrToFloat(Edit13.Text);
      FieldByName('SZ').AsFloat := StrToFloat(Edit14.Text);
      OpenDialog1.Filter := 'Objeto Wavefront (.obj)|*obj';
      OpenDialog1.InitialDir := ExtractFilePath(Application.ExeName) + 'Objetos';
      Timer1.Enabled := false;
      if OpenDialog1.Execute then
        begin
        FieldByName('Arquivo').AsString := ExtractFileName(OpenDialog1.FileName);
        // OBJ
        CopyFile(pchar(OpenDialog1.FileName),pchar(ExtractFilePath(ClientDataSet1.FileName)+ExtractFileName(OpenDialog1.FileName)),true);
        // MTL
        CopyFile(pchar(copy(OpenDialog1.FileName,1,length(OpenDialog1.FileName)-3) + 'mtl'),pchar(copy(ExtractFilePath(ClientDataSet1.FileName)+ExtractFileName(OpenDialog1.FileName),1, length(ExtractFilePath(ClientDataSet1.FileName)+ExtractFileName(OpenDialog1.FileName))-3) + 'mtl'),true);
        end;
      Timer1.Enabled := true;
      end;
    Post;
    end;

   reg := ClientDataSet1.RecordCount;
   if UpperCase(Copy(Edit1.Text,1,6)) = 'OBJETO' then
     edit1.Text := 'Objeto' + IntToStr(StrToInt(copy(Edit1.Text,7,3))+1);
   RadioGroup3.Enabled := false;  

end;

procedure GetMinMax(var M : TModel);
var I : Integer;
begin
  // Find the min and max in each coordinate system
  with M do
  begin
    BoundingBox.min.X := 0;
    BoundingBox.min.Y := 0;
    BoundingBox.min.Z := 0;
    BoundingBox.med := BoundingBox.min;
    BoundingBox.max := BoundingBox.min;

    For I :=1 to Vertices do
    begin
      if Vertex[I].X < BoundingBox.min.X then BoundingBox.min.X := Vertex[I].X
      else if Vertex[I].X > BoundingBox.max.X then BoundingBox.max.X := Vertex[I].X;

      if Vertex[I].Y < BoundingBox.min.Y then BoundingBox.min.Y := Vertex[I].Y
      else if Vertex[I].Y > BoundingBox.max.Y then BoundingBox.max.Y := Vertex[I].Y;

      if Vertex[I].Z < BoundingBox.min.Z then BoundingBox.min.Z := Vertex[I].Z
      else if Vertex[I].Z > BoundingBox.max.Z then BoundingBox.max.Z := Vertex[I].Z;
    end;

  BoundingBox.med.X := (BoundingBox.max.X+BoundingBox.min.X)/2;
  BoundingBox.med.Y := (BoundingBox.max.Y+BoundingBox.min.Y)/2;
  BoundingBox.med.Z := (BoundingBox.max.Z+BoundingBox.min.Z)/2;

  if BoundingBox.max.X-BoundingBox.min.X > BoundingBox.max.Y-BoundingBox.min.Y
    then BoundingBox.maxdim := BoundingBox.max.X-BoundingBox.min.X
    else BoundingBox.maxdim := BoundingBox.max.Y-BoundingBox.min.Y;
  if BoundingBox.max.Z-BoundingBox.min.Z > BoundingBox.maxdim
    then BoundingBox.maxdim := BoundingBox.max.Z-BoundingBox.min.Z

  end;
end;


procedure desenhaEsfera(raio,x,y,z,sx,sy,sz,ang,ax,ay,az,r,g,b,a: real; usacor: boolean);
var q: GLUquadricObj;
begin
    glPushMatrix;
      if a > 0 then
        glEnable(GL_BLEND);

      if usacor
        then glColor4f(r,g,b,a)
        else glColor4f(1,1,1,1);
      glScalef(sx,sy,sz);
      glTranslatef(x,y,z);
      glRotatef(ang,ax,ay,az);
      q := gluNewQuadric();
      //gluQuadricDrawStyle(q, GLU_LINE);
      gluSphere(q,raio,10,10);
      gluDeleteQuadric(q);

      glDisable(GL_BLEND);
    glPopMatrix;
end;

procedure desenhaCapsula(raio,comprimento,x,y,z,sx,sy,sz,ang,ax,ay,az,r,g,b,a: real; usacor: boolean);
var q: GLUquadricObj;
begin
    glPushMatrix;
      if usacor then glColor4f(r,g,b,a);
      glTranslatef(x,y,z);
      glRotatef(ang,ax,ay,az);
      q := gluNewQuadric();
      //gluQuadricDrawStyle(q, GLU_LINE);
      gluSphere(q,raio,10,10);
      gluCylinder(q,raio,raio,comprimento,10,10);
      glTranslatef(0,0,comprimento);
      gluSphere(q,raio,10,10);
      gluDeleteQuadric(q);
    glPopMatrix;
end;

procedure desenhaCubo(Lx,Ly,Lz,x,y,z,sx,sy,sz,ang,ax,ay,az,r,g,b,a: real; usacor: boolean);
  procedure face(render: Integer);
  var u,v,du,dv: real; n:integer;
  begin
  u:=-1/2;
  v:=-1/2;
  if render = GL_QUADS then
    begin
    n := 10;
    du:=1/n;
    dv:=1/n;
    glEnable(GL_NORMALIZE);
    glNormal3f(1,0,0);
    while u<(1/2) do
      begin
      v:=-1/2;
      while v<(1/2) do
        begin
        glBegin(render);
          glVertex3f(1/2,u,v);
          glvertex3f(1/2,u,v+dv);
          glvertex3f(1/2,u+du,v+dv);
          glvertex3f(1/2,u+du,v);
        glEnd;
        v:=v+dv;
        end;
        u:=u+du;
      end;
    end
    else
    begin
        du:=1;
        dv:=1;
        glBegin(render);
          glVertex3f(1/2,u,v);
          glvertex3f(1/2,u,v+dv);
          glvertex3f(1/2,u+du,v+dv);
          glvertex3f(1/2,u+du,v);
        glEnd;
    end;
  end;

var render: integer;
begin
    render := GL_QUADS;

    glPushMatrix;
      if usacor then glColor4f(r,g,b,a);
      glTranslatef(x,y,z);
      glScalef(Lx,Ly,Lz);
      glRotatef(ang,ax,ay,az);

      face(render);
      glRotate(90,0,0,1); face(render);
      glRotate(90,0,0,1); face(render);
      glRotate(90,0,0,1); face(render);
      glRotate(-90,0,1,0); face(render);
      glRotate(-180,0,1,0); face(render);
      glLoadIdentity;

    glPopMatrix;
end;

procedure desenhaPlano(a,b,c,d,Lx,Ly,cr,cg,cb,ca: real; usacor: boolean; render: integer);
var u,v,du,dv: real; n:integer;
begin
if usacor then glColor4f(cr,cg,cb,ca);

u:=-1/2*Lx;
v:=-1/2*Ly;
n := 10;
du:=Lx/n;
dv:=Ly/n;
glEnable(GL_NORMALIZE);
glNormal3f(a,b,c);
while u<(1/2*Lx-du) do
  begin
  v:=-1/2*Ly;
  while v<(1/2*Ly-dv) do
    begin
    glBegin(render);
      glVertex3f(u,v,-(d+a*u+b*v)/c);
      glvertex3f(u,v+dv,-(d+a*u+b*(v+dv))/c);
      glvertex3f(u+du,v+dv,-(d+a*(u+du)+b*(v+dv))/c);
      glvertex3f(u+du,v,-(d+a*(u+du)+b*v)/c);
    glEnd;
    v:=v+dv;
    end;
    u:=u+du;
  end;
end;

procedure desenhaTrimesh(FileName: string;x,y,z,sx,sy,sz,ang,ax,ay,az,r,g,b,a: real; usacor: boolean);
var
  M: TModel;
  BoundingBox: TBoundingBox;
begin
    glPushMatrix;
      glScalef(sx,sy,sz);
      glTranslatef(x,y,z);
      glRotatef(ang,ax,ay,az);

      M := LoadModel(FileName);
      GetMinMax(M);
      DrawModel(M);

    glPopMatrix;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
var i: integer;
begin
  Label14.Caption := 'Registro atual: ' + IntToStr(reg);
  t := t + 0.1;
  glClearColor(0,0,0,0);
  glClear(GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT);
  if ClientDataSet1.Active then
    begin
    glMatrixMode(GL_PROJECTION);
    glLoadIdentity;
    glOrtho(-10-zoom,10+zoom,-10-zoom,10+zoom,-10000,10000);
//    gluLookAt(5*sin(t),5*cos(t),2.5,0,0,0,0,0,1);
    gluLookAt(5+CamX,5+CamY,2.5+CamZ,0,0,0,0,0,1);
    glMatrixMode(GL_MODELVIEW);
    glLoadIdentity;

    glDisable(GL_LIGHTING);
    glBegin(GL_LINES);
      glColor3f(1,0,0); glVertex3f(0,0,0); glVertex3f(10+zoom,0,0);
      glColor3f(0,1,0); glVertex3f(0,0,0); glVertex3f(0,10+zoom,0);
      glColor3f(0,0,1); glVertex3f(0,0,0); glVertex3f(0,0,10+zoom);
    glEnd();
    glEnable(GL_LIGHTING);


    with ClientDataSet1 do
    for i := 1 to RecordCount do
      begin
      RecNo := i;

      kd[0] := FieldByName('R').AsFloat/255;
      kd[1] := FieldByName('G').AsFloat/255;
      kd[2] := FieldByName('B').AsFloat/255;
      kd[3] := FieldByName('A').AsFloat/255;

      glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT, @ka);
      glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE, @kd);
      glMaterialfv(GL_FRONT_AND_BACK, GL_SPECULAR, @ks);
      glMaterialf(GL_FRONT_AND_BACK, GL_SHININESS, 20);

      case FieldByName('ODETipo').AsInteger of
        0: desenhaEsfera(
                           FieldByName('Dim1').AsFloat,
                           FieldByName('X').AsFloat,
                           FieldByName('Y').AsFloat,
                           FieldByName('Z').AsFloat,
                           FieldByName('SX').AsFloat,
                           FieldByName('SY').AsFloat,
                           FieldByName('SZ').AsFloat,
                           FieldByName('Ang').AsFloat,
                           FieldByName('eixoX').AsFloat,
                           FieldByName('eixoY').AsFloat,
                           100*t+FieldByName('eixoZ').AsFloat,
                           FieldByName('R').AsFloat/255,
                           FieldByName('G').AsFloat/255,
                           FieldByName('B').AsFloat/255,
                           FieldByName('A').AsFloat/255,
                           FieldByName('UsaCor').AsBoolean);
        1: desenhaCapsula(
                           FieldByName('Dim1').AsFloat,
                           FieldByName('Dim2').AsFloat,
                           FieldByName('X').AsFloat,
                           FieldByName('Y').AsFloat,
                           FieldByName('Z').AsFloat,
                           FieldByName('SX').AsFloat,
                           FieldByName('SY').AsFloat,
                           FieldByName('SZ').AsFloat,
                           FieldByName('Ang').AsFloat,
                           FieldByName('eixoX').AsFloat,
                           FieldByName('eixoY').AsFloat,
                           FieldByName('eixoZ').AsFloat,
                           FieldByName('R').AsFloat/255,
                           FieldByName('G').AsFloat/255,
                           FieldByName('B').AsFloat/255,
                           FieldByName('A').AsFloat/255,
                           FieldByName('UsaCor').AsBoolean);
        2: desenhaCubo(
                           FieldByName('Dim1').AsFloat,
                           FieldByName('Dim2').AsFloat,
                           FieldByName('Dim3').AsFloat,
                           FieldByName('X').AsFloat,
                           FieldByName('Y').AsFloat,
                           FieldByName('Z').AsFloat,
                           FieldByName('SX').AsFloat,
                           FieldByName('SY').AsFloat,
                           FieldByName('SZ').AsFloat,
                           FieldByName('Ang').AsFloat,
                           FieldByName('eixoX').AsFloat,
                           FieldByName('eixoY').AsFloat,
                           FieldByName('eixoZ').AsFloat,
                           FieldByName('R').AsFloat/255,
                           FieldByName('G').AsFloat/255,
                           FieldByName('B').AsFloat/255,
                           FieldByName('A').AsFloat/255,
                           FieldByName('UsaCor').AsBoolean);
        3: desenhaPlano(
                           FieldByName('Dim1').AsFloat,
                           FieldByName('Dim2').AsFloat,
                           FieldByName('Dim3').AsFloat,
                           FieldByName('Dim4').AsFloat,
                           FieldByName('SX').AsFloat,
                           FieldByName('SY').AsFloat,
                           FieldByName('R').AsFloat/255,
                           FieldByName('G').AsFloat/255,
                           FieldByName('B').AsFloat/255,
                           FieldByName('A').AsFloat/255,
                           FieldByName('UsaCor').AsBoolean,
                           GL_LINE_LOOP);
        4: desenhaTriMesh(
                           FieldByName('Arquivo').AsString,
                           FieldByName('X').AsFloat,
                           FieldByName('Y').AsFloat,
                           FieldByName('Z').AsFloat,
                           FieldByName('SX').AsFloat,
                           FieldByName('SY').AsFloat,
                           FieldByName('SZ').AsFloat,
                           FieldByName('Ang').AsFloat,
                           FieldByName('eixoX').AsFloat,
                           FieldByName('eixoY').AsFloat,
                           FieldByName('eixoZ').AsFloat,
                           FieldByName('R').AsFloat/255,
                           FieldByName('G').AsFloat/255,
                           FieldByName('B').AsFloat/255,
                           FieldByName('A').AsFloat/255,
                           FieldByName('UsaCor').AsBoolean);
      end;
    end;


    glDisable(GL_LIGHTING);
      desenhaEsfera(0.5,LightPos1[0],LightPos1[1],LightPos1[2],1,1,1,0,0,0,0,1,1,0,0,true);
      desenhaEsfera(0.5,LightPos2[0],LightPos2[1],LightPos2[2],1,1,1,0,0,0,0,1,1,0,0,true);
      desenhaEsfera(0.5,LightPos3[0],LightPos3[1],LightPos3[2],1,1,1,0,0,0,0,1,1,0,0,true);
    glEnd();
    glEnable(GL_LIGHTING);

    OGLPanel1.Swap;
    end;
end;

procedure TForm1.TrackBar1Change(Sender: TObject);
var t: real;
    c: integer;
    r,g,b: byte;
begin
//  c := ColorToRGB(StringToColor('clBtnFace'));
  c := ColorToRGB(Form1.Color);
  t := 1-(trackBar1.position / TrackBar1.Max);

  r := round(getRValue(Shape1.Brush.Color)*t + GetRValue(c)*(1-t));
  g := round(getGValue(Shape1.Brush.Color)*t + GetGValue(c)*(1-t));
  b := round(getBValue(Shape1.Brush.Color)*t + GetBValue(c)*(1-t));

  Shape2.Brush.Color := RGB(r,g,b);
  Shape2.pen.Color := RGB(r,g,b);

  Label9.Caption := Format('R: %d  G: %d  B: %d  a: %d',
     [getRValue(Shape1.Brush.Color),
      getGValue(Shape1.Brush.Color),
      getBValue(Shape1.Brush.Color),
      trackBar1.position]);

end;

procedure TForm1.RadioGroup1Click(Sender: TObject);
begin
  Label2.Caption := 'X';
  Label3.Caption := 'Y';
  Label4.Visible := true;
  Label10.Visible := false;
  Label11.Visible := false;
  Label12.Visible := false;
  Label13.Visible := false;
  Label15.Visible := false;
  Label16.Visible := false;
  Label17.Visible := false;
  Label18.Visible := true;
  Label6.Visible := true;
  Label7.Visible := true;
  Label8.Visible := true;
  Label19.Visible := true;
  CheckBox1.Visible := true;
  CheckBox3.Visible := true;
  CheckBox4.Visible := true;
  CheckBox5.Visible := true;
  CheckBox6.Visible := true;
  CheckBox7.Visible := true;
  RadioGroup2.Visible := true;

  case RadioGroup1.ItemIndex of
  0: begin // esfera
     Label10.Caption := 'Raio';
     Label10.Visible := true;
     end;
  1: begin // capsula
     Label10.Caption := 'Raio';
     Label11.Caption := 'Compr';
     Label10.Visible := true;
     Label11.Visible := true;
     end;
  2: begin // cubo
     Label10.Caption := 'Lx';
     Label11.Caption := 'Ly';
     Label12.Caption := 'Lz';
     Label10.Visible := true;
     Label11.Visible := true;
     Label12.Visible := true;
     end;
  3: begin // plano
     Label2.Caption := 'TamU';
     Label3.Caption := 'TamV';
     Label10.Caption := 'a';
     Label11.Caption := 'b';
     Label12.Caption := 'c';
     Label13.Caption := 'd';
     Label10.Visible := true;
     Label11.Visible := true;
     Label12.Visible := true;
     Label13.Visible := true;
     Label18.Visible := false;
     Label6.Visible := false;
     Label7.Visible := false;
     Label8.Visible := false;
     Label19.Visible := false;
     Label4.Visible := false;
     CheckBox1.Visible := false;
     CheckBox3.Visible := false;
     CheckBox4.Visible := false;
     CheckBox5.Visible := false;
     CheckBox6.Visible := false;
     CheckBox7.Visible := false;
     RadioGroup2.Visible := false;
     end;
  4: begin // arquivo
     Label15.Visible := true;
     Label16.Visible := true;
     Label17.Visible := true;
     end;
  end;

  Edit4.Visible := Label4.Visible;
  Edit5.Visible := Label6.Visible;
  Edit6.Visible := Label7.Visible;
  Edit7.Visible := Label8.Visible;
  Edit8.Visible := Label10.Visible;
  Edit9.Visible := Label11.Visible;
  Edit10.Visible := Label12.Visible;
  Edit11.Visible := Label13.Visible;
  Edit12.Visible := Label15.Visible;
  Edit13.Visible := Label16.Visible;
  Edit14.Visible := Label17.Visible;
  Edit15.Visible := Label18.Visible;
  Edit16.Visible := Label19.Visible;
end;

procedure TForm1.Button5Click(Sender: TObject);
begin
  with ClientDataSet1 do
    begin
    RecNo := reg;
    Edit;
    FieldByName('Nome').AsString := Edit1.Text;
    FieldByName('X').AsFloat := StrToFloat(Edit2.Text);
    FieldByName('Y').AsFloat := StrToFloat(Edit3.Text);
    FieldByName('Z').AsFloat := StrToFloat(Edit4.Text);
    FieldByName('SX').AsFloat := 1;
    FieldByName('SY').AsFloat := 1;
    FieldByName('SZ').AsFloat := 1;
    FieldByName('UserMove').AsBoolean := CheckBox6.Checked;
    FieldByName('MoveX').AsBoolean := CheckBox8.Checked;
    FieldByName('MoveY').AsBoolean := CheckBox9.Checked;
    FieldByName('MoveZ').AsBoolean := CheckBox10.Checked;
    FieldByName('ODEMove').AsBoolean := CheckBox1.Checked;
    FieldByName('ODETipo').AsInteger := RadioGroup1.itemindex;
    FieldByName('Ang').AsFloat := StrToFloat(Edit16.Text);
    FieldByName('eixoX').AsFloat := StrToFloat(Edit5.Text);
    FieldByName('eixoY').AsFloat := StrToFloat(Edit6.Text);
    FieldByName('eixoZ').AsFloat := StrToFloat(Edit7.Text);
    FieldByName('TemGravidade').AsBoolean := CheckBox7.Checked;
    FieldByName('Atrito').AsFloat := StrToFloat(Edit17.Text);
    FieldByName('UsaCor').AsBoolean := CheckBox2.Checked;
    if FieldByName('UsaCor').AsBoolean then
      begin
      FieldByName('R').AsInteger := GetRValue(Shape1.Brush.Color);
      FieldByName('G').AsInteger := GetGValue(Shape1.Brush.Color);
      FieldByName('B').AsInteger := GetBValue(Shape1.Brush.Color);
      end;
    FieldByName('A').AsInteger := TrackBar1.Position;
    FieldByName('MostraVecV').AsBoolean := CheckBox3.Checked;
    FieldByName('MostraVecA').AsBoolean := CheckBox4.Checked;
    FieldByName('MostraEixoRot').AsBoolean := CheckBox5.Checked;
    FieldByName('TipoDeColisao').AsInteger := RadioGroup3.ItemIndex;
    FieldByName('MostraRastroSempre').AsBoolean := RadioGroup2.ItemIndex = 1;
    FieldByName('MostraRastroSolto').AsBoolean := RadioGroup2.ItemIndex = 2;

    if Edit15.Visible then
      FieldByName('Massa').AsFloat := StrToFloat(Edit15.Text);
    if Edit8.Visible then
      FieldByName('Dim1').AsFloat := StrToFloat(Edit8.Text);
    if Edit9.Visible then
      FieldByName('Dim2').AsFloat := StrToFloat(Edit9.Text);
    if Edit10.Visible then
      FieldByName('Dim3').AsFloat := StrToFloat(Edit10.Text);
    if Edit11.Visible then
      FieldByName('Dim4').AsFloat := StrToFloat(Edit11.Text);

    if RadioGroup1.ItemIndex = RadioGroup1.Items.Count-1 then
      begin
      FieldByName('SX').AsFloat := StrToFloat(Edit12.Text);
      FieldByName('SY').AsFloat := StrToFloat(Edit13.Text);
      FieldByName('SZ').AsFloat := StrToFloat(Edit14.Text);

      OpenDialog1.Filter := 'Objeto Wavefront (.obj)|*obj';
      OpenDialog1.InitialDir := ExtractFilePath(Application.ExeName) + 'Objetos';
      if OpenDialog1.Execute then
        FieldByName('Arquivo').AsString := OpenDialog1.FileName;
      end;
    Post;
    end;

end;

procedure TForm1.Shape1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var tb: integer;
begin
  if ColorDialog1.Execute then
    begin
    Shape1.Brush.Color := ColorDialog1.Color;
    TrackBar1Change(Self);
    end;
end;

procedure TForm1.DBNavigator1Click(Sender: TObject; Button: TNavigateBtn);
begin
Shape1.Brush.Color := clWhite;

if Button = nbNext then
  begin
  Inc(reg);
  if reg > ClientDataSet1.RecordCount
    then reg := ClientDataSet1.RecordCount;
  end;
if Button = nbPrior then
  begin
  dec(reg);
  if reg < 1
    then reg := 1;
  end;

ClientDataSet1.RecNo := reg;

  with ClientDataSet1 do
    begin
    Edit1.Text := FieldByName('Nome').AsString;
    Edit2.Text := FloatToStr(FieldByName('X').AsFloat);
    Edit3.Text := FloatToStr(FieldByName('Y').AsFloat);
    Edit4.Text := FloatToStr(FieldByName('Z').AsFloat);
    CheckBox6.Checked := FieldByName('UserMove').AsBoolean;
    CheckBox8.Checked := FieldByName('MoveX').AsBoolean;
    CheckBox9.Checked := FieldByName('MoveY').AsBoolean;
    CheckBox10.Checked := FieldByName('MoveZ').AsBoolean;
    CheckBox1.Checked := FieldByName('ODEMove').AsBoolean;
    RadioGroup1.ItemIndex := FieldByName('ODETipo').AsInteger;
    Edit15.Text := FloatToStr(FieldByName('Massa').AsFloat);
    Edit16.Text := FloatToStr(FieldByName('Ang').AsFloat);
    Edit5.Text := FloatToStr(FieldByName('eixoX').AsFloat);
    Edit6.Text := FloatToStr(FieldByName('eixoY').AsFloat);
    Edit7.Text := FloatToStr(FieldByName('eixoZ').AsFloat);
    Edit12.Text := FloatToStr(FieldByName('Sx').AsFloat);
    Edit13.Text := FloatToStr(FieldByName('Sy').AsFloat);
    Edit14.Text := FloatToStr(FieldByName('Sz').AsFloat);
    CheckBox7.Checked := FieldByName('TemGravidade').AsBoolean;
    Edit17.Text := FloatToStr(FieldByName('Atrito').AsFloat);

    CheckBox2.Checked := FieldByName('UsaCor').AsBoolean;
    if FieldByName('UsaCor').AsBoolean then
      begin
      Shape1.Brush.Color := RGB(
          FieldByName('R').AsInteger,
          FieldByName('G').AsInteger,
          FieldByName('B').AsInteger);
      TrackBar1.Position := FieldByName('A').AsInteger;
      end;

     Edit8.Text := FloatToStr(FieldByName('Dim1').AsFloat);
     Edit9.Text := FloatToStr(FieldByName('Dim2').AsFloat);
     Edit10.Text := FloatToStr(FieldByName('Dim3').AsFloat);
     Edit11.Text := FloatToStr(FieldByName('Dim4').AsFloat);

    if FieldByName('ODETipo').AsInteger = 4 then
      SaveDialog1.FileName := FieldByName('Arquivo').AsString;
    end;

end;

procedure TForm1.SpinButton1DownClick(Sender: TObject);
begin
zoom := zoom + 1;
Label21.Caption := 'Zoom: ' + FloatToStrF(-zoom,ffFixed,0,1);
end;

procedure TForm1.SpinButton1UpClick(Sender: TObject);
begin
zoom := zoom - 1;
Label21.Caption := 'Zoom: ' + FloatToStrF(-zoom,ffFixed,0,1);
end;

procedure TForm1.SpinButton2DownClick(Sender: TObject);
begin
  LightDif[0] := LightDif[0] - 0.03;
  LightDif[1] := LightDif[1] - 0.03;
  LightDif[2] := LightDif[2] - 0.03;
  if LightDif[0] < 0 then LightDif[0] := 0;
  if LightDif[1] < 0 then LightDif[1] := 0;
  if LightDif[2] < 0 then LightDif[2] := 0;

  glLightfv(GL_LIGHT1, GL_DIFFUSE, @LightDif);
  glLightfv(GL_LIGHT2, GL_DIFFUSE, @LightDif);
  glLightfv(GL_LIGHT3, GL_DIFFUSE, @LightDif);
  Label20.Caption := 'Luz: ' + FloatToStrF(LightDif[0], ffFixed,0, 2);
end;

procedure TForm1.SpinButton2UpClick(Sender: TObject);
begin
  LightDif[0] := LightDif[0] + 0.03;
  LightDif[1] := LightDif[1] + 0.03;
  LightDif[2] := LightDif[2] + 0.03;
  if LightDif[0] > 1 then LightDif[0] := 1;
  if LightDif[1] > 1 then LightDif[1] := 1;
  if LightDif[2] > 1 then LightDif[2] := 1;
  glLightfv(GL_LIGHT1, GL_DIFFUSE, @LightDif);
  glLightfv(GL_LIGHT2, GL_DIFFUSE, @LightDif);
  glLightfv(GL_LIGHT3, GL_DIFFUSE, @LightDif);
  Label20.Caption := 'Luz: ' + FloatToStrF(LightDif[0], ffFixed,0, 2);
end;

procedure TForm1.SpinButton3DownClick(Sender: TObject);
begin
  CamX := CamX - 0.1;
end;

procedure TForm1.SpinButton3UpClick(Sender: TObject);
begin
  CamX := CamX + 0.1;
end;

procedure TForm1.SpinButton4UpClick(Sender: TObject);
begin
  CamY := CamY + 0.1;
end;

procedure TForm1.SpinButton4DownClick(Sender: TObject);
begin
  CamY := CamY - 0.1;
end;

procedure TForm1.SpinButton5DownClick(Sender: TObject);
begin
  CamZ := CamZ - 0.1;
end;

procedure TForm1.SpinButton5UpClick(Sender: TObject);
begin
  CamZ := CamZ + 0.1;
end;

end.
